%%------------------------------------------------------------
%%
%% Implementation stub file
%% 
%% Target: CosEventDomainAdmin_EventDomain
%% Source: /tmp/a/ports/lang/erlang/work/otp_src_R9B-0/lib/cosEventDomain/src/CosEventDomainAdmin.idl
%% IC vsn: 4.1.6
%% 
%% This file is automatically generated. DO NOT EDIT IT.
%%
%%------------------------------------------------------------

-module('CosEventDomainAdmin_EventDomain').
-ic_compiled("4_1_6").


%% Interface functions
-export([add_channel/2, get_all_channels/1, get_channel/2]).
-export([remove_channel/2, add_connection/2, get_all_connections/1]).
-export([get_connection/2, remove_connection/2, get_offer_channels/2]).
-export([get_subscription_channels/2, destroy/1, get_cycles/1]).
-export([get_diamonds/1, set_default_consumer_channel/2, set_default_supplier_channel/2]).
-export([connect_push_consumer/2, connect_pull_consumer/2, connect_push_supplier/2]).
-export([connect_pull_supplier/2, connect_structured_push_consumer/2, connect_structured_pull_consumer/2]).
-export([connect_structured_push_supplier/2, connect_structured_pull_supplier/2, connect_sequence_push_consumer/2]).
-export([connect_sequence_pull_consumer/2, connect_sequence_push_supplier/2, connect_sequence_pull_supplier/2]).
-export([connect_push_consumer_with_id/3, connect_pull_consumer_with_id/3, connect_push_supplier_with_id/3]).
-export([connect_pull_supplier_with_id/3, connect_structured_push_consumer_with_id/3, connect_structured_pull_consumer_with_id/3]).
-export([connect_structured_push_supplier_with_id/3, connect_structured_pull_supplier_with_id/3, connect_sequence_push_consumer_with_id/3]).
-export([connect_sequence_pull_consumer_with_id/3, connect_sequence_push_supplier_with_id/3, connect_sequence_pull_supplier_with_id/3]).

%% Exports from "CosNotification::QoSAdmin"
-export([get_qos/1, set_qos/2, validate_qos/2]).

%% Exports from "CosNotification::AdminPropertiesAdmin"
-export([get_admin/1, set_admin/2]).

%% Type identification function
-export([typeID/0]).

%% Used to start server
-export([oe_create/0, oe_create_link/0, oe_create/1]).
-export([oe_create_link/1, oe_create/2, oe_create_link/2]).
-export([oe_is_a/1]).

-export([start/1, start_link/1]).

%% gen server export stuff
-behaviour(gen_server).
-export([init/1, terminate/2, handle_call/3]).
-export([handle_cast/2, handle_info/2, code_change/3]).

-include_lib("orber/include/corba.hrl").


%%------------------------------------------------------------
%%
%% Object interface functions.
%%
%%------------------------------------------------------------



%%%% Operation: add_channel
%% 
%%   Returns: RetVal
%%
add_channel(OE_THIS, Channel) ->
    corba:call(OE_THIS, add_channel, [Channel], {tk_long,
                                                    [{tk_objref,
                                                         "IDL:omg.org/CosNotifyChannelAdmin/EventChannel:1.0",
                                                         "EventChannel"}],
                                                    []}, infinity).

%%%% Operation: get_all_channels
%% 
%%   Returns: RetVal
%%
get_all_channels(OE_THIS) ->
    corba:call(OE_THIS, get_all_channels, [], {{tk_sequence,tk_long,0},[],[]}, infinity).

%%%% Operation: get_channel
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
get_channel(OE_THIS, Channel) ->
    corba:call(OE_THIS, get_channel, [Channel], {{tk_objref,
                                                     "IDL:omg.org/CosNotifyChannelAdmin/EventChannel:1.0",
                                                     "EventChannel"},
                                                 [tk_long],
                                                 []}, infinity).

%%%% Operation: remove_channel
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
remove_channel(OE_THIS, Channel) ->
    corba:call(OE_THIS, remove_channel, [Channel], {tk_void,[tk_long],[]}, infinity).

%%%% Operation: add_connection
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound, CosEventChannelAdmin::TypeError, CosEventDomainAdmin::AlreadyExists, CosEventDomainAdmin::CycleCreationForbidden, CosEventDomainAdmin::DiamondCreationForbidden
%%
add_connection(OE_THIS, Connection) ->
    corba:call(OE_THIS, add_connection, [Connection], {tk_long,
                                                          [{tk_struct,
                                                               "IDL:omg.org/CosEventDomainAdmin/Connection:1.0",
                                                               "Connection",
                                                               [{"supplier_id",
                                                                 tk_long},
                                                                {"consumer_id",
                                                                 tk_long},
                                                                {"ctype",
                                                                 {tk_enum,
                                                                     "IDL:omg.org/CosNotifyChannelAdmin/ClientType:1.0",
                                                                     "ClientType",
                                                                     ["ANY_EVENT",
                                                                      "STRUCTURED_EVENT",
                                                                      "SEQUENCE_EVENT"]}},
                                                                {"notification_style",
                                                                 {tk_enum,
                                                                     "IDL:omg.org/CosEventDomainAdmin/NotificationStyle:1.0",
                                                                     "NotificationStyle",
                                                                     ["Push",
                                                                      "Pull"]}}]}],
                                                          []}, infinity).

%%%% Operation: get_all_connections
%% 
%%   Returns: RetVal
%%
get_all_connections(OE_THIS) ->
    corba:call(OE_THIS, get_all_connections, [], {{tk_sequence,tk_long,0},
                                                  [],
                                                  []}, infinity).

%%%% Operation: get_connection
%% 
%%   Returns: RetVal
%%   Raises:  CosEventDomainAdmin::ConnectionNotFound
%%
get_connection(OE_THIS, Connection) ->
    corba:call(OE_THIS, get_connection, [Connection], {{tk_struct,
                                                           "IDL:omg.org/CosEventDomainAdmin/Connection:1.0",
                                                           "Connection",
                                                           [{"supplier_id",
                                                             tk_long},
                                                            {"consumer_id",
                                                             tk_long},
                                                            {"ctype",
                                                             {tk_enum,
                                                                 "IDL:omg.org/CosNotifyChannelAdmin/ClientType:1.0",
                                                                 "ClientType",
                                                                 ["ANY_EVENT",
                                                                  "STRUCTURED_EVENT",
                                                                  "SEQUENCE_EVENT"]}},
                                                            {"notification_style",
                                                             {tk_enum,
                                                                 "IDL:omg.org/CosEventDomainAdmin/NotificationStyle:1.0",
                                                                 "NotificationStyle",
                                                                 ["Push",
                                                                  "Pull"]}}]},
                                                       [tk_long],
                                                       []}, infinity).

%%%% Operation: remove_connection
%% 
%%   Returns: RetVal
%%   Raises:  CosEventDomainAdmin::ConnectionNotFound
%%
remove_connection(OE_THIS, Connection) ->
    corba:call(OE_THIS, remove_connection, [Connection], {tk_void,
                                                             [tk_long],
                                                             []}, infinity).

%%%% Operation: get_offer_channels
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
get_offer_channels(OE_THIS, Channel) ->
    corba:call(OE_THIS, get_offer_channels, [Channel], {{tk_sequence,
                                                            tk_long,
                                                            0},
                                                        [tk_long],
                                                        []}, infinity).

%%%% Operation: get_subscription_channels
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
get_subscription_channels(OE_THIS, Channel) ->
    corba:call(OE_THIS, get_subscription_channels, [Channel], {{tk_sequence,
                                                                   tk_long,
                                                                   0},
                                                               [tk_long],
                                                               []}, infinity).

%%%% Operation: destroy
%% 
%%   Returns: RetVal
%%
destroy(OE_THIS) ->
    corba:call(OE_THIS, destroy, [], {tk_void,[],[]}, infinity).

%%%% Operation: get_cycles
%% 
%%   Returns: RetVal
%%
get_cycles(OE_THIS) ->
    corba:call(OE_THIS, get_cycles, [], {{tk_sequence,
                                             {tk_sequence,tk_long,0},
                                             0},
                                         [],
                                         []}, infinity).

%%%% Operation: get_diamonds
%% 
%%   Returns: RetVal
%%
get_diamonds(OE_THIS) ->
    corba:call(OE_THIS, get_diamonds, [], {{tk_sequence,
                                               {tk_sequence,
                                                   {tk_sequence,tk_long,0},
                                                   0},
                                               0},
                                           [],
                                           []}, infinity).

%%%% Operation: set_default_consumer_channel
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
set_default_consumer_channel(OE_THIS, Channel) ->
    corba:call(OE_THIS, set_default_consumer_channel, [Channel], {tk_void,
                                                                     [tk_long],
                                                                     []}, infinity).

%%%% Operation: set_default_supplier_channel
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
set_default_supplier_channel(OE_THIS, Channel) ->
    corba:call(OE_THIS, set_default_supplier_channel, [Channel], {tk_void,
                                                                     [tk_long],
                                                                     []}, infinity).

%%%% Operation: connect_push_consumer
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
connect_push_consumer(OE_THIS, Client) ->
    corba:call(OE_THIS, connect_push_consumer, [Client], {{tk_objref,
                                                              "IDL:omg.org/CosNotifyChannelAdmin/ProxyPushSupplier:1.0",
                                                              "ProxyPushSupplier"},
                                                          [{tk_objref,
                                                               "IDL:omg.org/CosEventComm/PushConsumer:1.0",
                                                               "PushConsumer"}],
                                                          []}, infinity).

%%%% Operation: connect_pull_consumer
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
connect_pull_consumer(OE_THIS, Client) ->
    corba:call(OE_THIS, connect_pull_consumer, [Client], {{tk_objref,
                                                              "IDL:omg.org/CosNotifyChannelAdmin/ProxyPullSupplier:1.0",
                                                              "ProxyPullSupplier"},
                                                          [{tk_objref,
                                                               "IDL:omg.org/CosEventComm/PullConsumer:1.0",
                                                               "PullConsumer"}],
                                                          []}, infinity).

%%%% Operation: connect_push_supplier
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
connect_push_supplier(OE_THIS, Client) ->
    corba:call(OE_THIS, connect_push_supplier, [Client], {{tk_objref,
                                                              "IDL:omg.org/CosNotifyChannelAdmin/ProxyPushConsumer:1.0",
                                                              "ProxyPushConsumer"},
                                                          [{tk_objref,
                                                               "IDL:omg.org/CosEventComm/PushSupplier:1.0",
                                                               "PushSupplier"}],
                                                          []}, infinity).

%%%% Operation: connect_pull_supplier
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
connect_pull_supplier(OE_THIS, Client) ->
    corba:call(OE_THIS, connect_pull_supplier, [Client], {{tk_objref,
                                                              "IDL:omg.org/CosNotifyChannelAdmin/ProxyPullConsumer:1.0",
                                                              "ProxyPullConsumer"},
                                                          [{tk_objref,
                                                               "IDL:omg.org/CosEventComm/PullSupplier:1.0",
                                                               "PullSupplier"}],
                                                          []}, infinity).

%%%% Operation: connect_structured_push_consumer
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
connect_structured_push_consumer(OE_THIS, Client) ->
    corba:call(OE_THIS, connect_structured_push_consumer, [Client], {{tk_objref,
                                                                         "IDL:omg.org/CosNotifyChannelAdmin/StructuredProxyPushSupplier:1.0",
                                                                         "StructuredProxyPushSupplier"},
                                                                     [{tk_objref,
                                                                          "IDL:omg.org/CosNotifyComm/StructuredPushConsumer:1.0",
                                                                          "StructuredPushConsumer"}],
                                                                     []}, infinity).

%%%% Operation: connect_structured_pull_consumer
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
connect_structured_pull_consumer(OE_THIS, Client) ->
    corba:call(OE_THIS, connect_structured_pull_consumer, [Client], {{tk_objref,
                                                                         "IDL:omg.org/CosNotifyChannelAdmin/StructuredProxyPullSupplier:1.0",
                                                                         "StructuredProxyPullSupplier"},
                                                                     [{tk_objref,
                                                                          "IDL:omg.org/CosNotifyComm/StructuredPullConsumer:1.0",
                                                                          "StructuredPullConsumer"}],
                                                                     []}, infinity).

%%%% Operation: connect_structured_push_supplier
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
connect_structured_push_supplier(OE_THIS, Client) ->
    corba:call(OE_THIS, connect_structured_push_supplier, [Client], {{tk_objref,
                                                                         "IDL:omg.org/CosNotifyChannelAdmin/StructuredProxyPushConsumer:1.0",
                                                                         "StructuredProxyPushConsumer"},
                                                                     [{tk_objref,
                                                                          "IDL:omg.org/CosNotifyComm/StructuredPushSupplier:1.0",
                                                                          "StructuredPushSupplier"}],
                                                                     []}, infinity).

%%%% Operation: connect_structured_pull_supplier
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
connect_structured_pull_supplier(OE_THIS, Client) ->
    corba:call(OE_THIS, connect_structured_pull_supplier, [Client], {{tk_objref,
                                                                         "IDL:omg.org/CosNotifyChannelAdmin/StructuredProxyPullConsumer:1.0",
                                                                         "StructuredProxyPullConsumer"},
                                                                     [{tk_objref,
                                                                          "IDL:omg.org/CosNotifyComm/StructuredPullSupplier:1.0",
                                                                          "StructuredPullSupplier"}],
                                                                     []}, infinity).

%%%% Operation: connect_sequence_push_consumer
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
connect_sequence_push_consumer(OE_THIS, Client) ->
    corba:call(OE_THIS, connect_sequence_push_consumer, [Client], {{tk_objref,
                                                                       "IDL:omg.org/CosNotifyChannelAdmin/SequenceProxyPushSupplier:1.0",
                                                                       "SequenceProxyPushSupplier"},
                                                                   [{tk_objref,
                                                                        "IDL:omg.org/CosNotifyComm/SequencePushConsumer:1.0",
                                                                        "SequencePushConsumer"}],
                                                                   []}, infinity).

%%%% Operation: connect_sequence_pull_consumer
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
connect_sequence_pull_consumer(OE_THIS, Client) ->
    corba:call(OE_THIS, connect_sequence_pull_consumer, [Client], {{tk_objref,
                                                                       "IDL:omg.org/CosNotifyChannelAdmin/SequenceProxyPullSupplier:1.0",
                                                                       "SequenceProxyPullSupplier"},
                                                                   [{tk_objref,
                                                                        "IDL:omg.org/CosNotifyComm/SequencePullConsumer:1.0",
                                                                        "SequencePullConsumer"}],
                                                                   []}, infinity).

%%%% Operation: connect_sequence_push_supplier
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
connect_sequence_push_supplier(OE_THIS, Client) ->
    corba:call(OE_THIS, connect_sequence_push_supplier, [Client], {{tk_objref,
                                                                       "IDL:omg.org/CosNotifyChannelAdmin/SequenceProxyPushConsumer:1.0",
                                                                       "SequenceProxyPushConsumer"},
                                                                   [{tk_objref,
                                                                        "IDL:omg.org/CosNotifyComm/SequencePushSupplier:1.0",
                                                                        "SequencePushSupplier"}],
                                                                   []}, infinity).

%%%% Operation: connect_sequence_pull_supplier
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
connect_sequence_pull_supplier(OE_THIS, Client) ->
    corba:call(OE_THIS, connect_sequence_pull_supplier, [Client], {{tk_objref,
                                                                       "IDL:omg.org/CosNotifyChannelAdmin/SequenceProxyPullConsumer:1.0",
                                                                       "SequenceProxyPullConsumer"},
                                                                   [{tk_objref,
                                                                        "IDL:omg.org/CosNotifyComm/SequencePullSupplier:1.0",
                                                                        "SequencePullSupplier"}],
                                                                   []}, infinity).

%%%% Operation: connect_push_consumer_with_id
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
connect_push_consumer_with_id(OE_THIS, Client, Channel) ->
    corba:call(OE_THIS, connect_push_consumer_with_id, [Client, Channel], {{tk_objref,
                                                                               "IDL:omg.org/CosNotifyChannelAdmin/ProxyPushSupplier:1.0",
                                                                               "ProxyPushSupplier"},
                                                                           [{tk_objref,
                                                                                "IDL:omg.org/CosEventComm/PushConsumer:1.0",
                                                                                "PushConsumer"},
                                                                            tk_long],
                                                                           []}, infinity).

%%%% Operation: connect_pull_consumer_with_id
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
connect_pull_consumer_with_id(OE_THIS, Client, Channel) ->
    corba:call(OE_THIS, connect_pull_consumer_with_id, [Client, Channel], {{tk_objref,
                                                                               "IDL:omg.org/CosNotifyChannelAdmin/ProxyPullSupplier:1.0",
                                                                               "ProxyPullSupplier"},
                                                                           [{tk_objref,
                                                                                "IDL:omg.org/CosEventComm/PullConsumer:1.0",
                                                                                "PullConsumer"},
                                                                            tk_long],
                                                                           []}, infinity).

%%%% Operation: connect_push_supplier_with_id
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
connect_push_supplier_with_id(OE_THIS, Client, Channel) ->
    corba:call(OE_THIS, connect_push_supplier_with_id, [Client, Channel], {{tk_objref,
                                                                               "IDL:omg.org/CosNotifyChannelAdmin/ProxyPushConsumer:1.0",
                                                                               "ProxyPushConsumer"},
                                                                           [{tk_objref,
                                                                                "IDL:omg.org/CosEventComm/PushSupplier:1.0",
                                                                                "PushSupplier"},
                                                                            tk_long],
                                                                           []}, infinity).

%%%% Operation: connect_pull_supplier_with_id
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
connect_pull_supplier_with_id(OE_THIS, Client, Channel) ->
    corba:call(OE_THIS, connect_pull_supplier_with_id, [Client, Channel], {{tk_objref,
                                                                               "IDL:omg.org/CosNotifyChannelAdmin/ProxyPullConsumer:1.0",
                                                                               "ProxyPullConsumer"},
                                                                           [{tk_objref,
                                                                                "IDL:omg.org/CosEventComm/PullSupplier:1.0",
                                                                                "PullSupplier"},
                                                                            tk_long],
                                                                           []}, infinity).

%%%% Operation: connect_structured_push_consumer_with_id
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
connect_structured_push_consumer_with_id(OE_THIS, Client, Channel) ->
    corba:call(OE_THIS, connect_structured_push_consumer_with_id, [Client, Channel], {{tk_objref,
                                                                                          "IDL:omg.org/CosNotifyChannelAdmin/StructuredProxyPushSupplier:1.0",
                                                                                          "StructuredProxyPushSupplier"},
                                                                                      [{tk_objref,
                                                                                           "IDL:omg.org/CosNotifyComm/StructuredPushConsumer:1.0",
                                                                                           "StructuredPushConsumer"},
                                                                                       tk_long],
                                                                                      []}, infinity).

%%%% Operation: connect_structured_pull_consumer_with_id
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
connect_structured_pull_consumer_with_id(OE_THIS, Client, Channel) ->
    corba:call(OE_THIS, connect_structured_pull_consumer_with_id, [Client, Channel], {{tk_objref,
                                                                                          "IDL:omg.org/CosNotifyChannelAdmin/StructuredProxyPullSupplier:1.0",
                                                                                          "StructuredProxyPullSupplier"},
                                                                                      [{tk_objref,
                                                                                           "IDL:omg.org/CosNotifyComm/StructuredPullConsumer:1.0",
                                                                                           "StructuredPullConsumer"},
                                                                                       tk_long],
                                                                                      []}, infinity).

%%%% Operation: connect_structured_push_supplier_with_id
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
connect_structured_push_supplier_with_id(OE_THIS, Client, Channel) ->
    corba:call(OE_THIS, connect_structured_push_supplier_with_id, [Client, Channel], {{tk_objref,
                                                                                          "IDL:omg.org/CosNotifyChannelAdmin/StructuredProxyPushConsumer:1.0",
                                                                                          "StructuredProxyPushConsumer"},
                                                                                      [{tk_objref,
                                                                                           "IDL:omg.org/CosNotifyComm/StructuredPushSupplier:1.0",
                                                                                           "StructuredPushSupplier"},
                                                                                       tk_long],
                                                                                      []}, infinity).

%%%% Operation: connect_structured_pull_supplier_with_id
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
connect_structured_pull_supplier_with_id(OE_THIS, Client, Channel) ->
    corba:call(OE_THIS, connect_structured_pull_supplier_with_id, [Client, Channel], {{tk_objref,
                                                                                          "IDL:omg.org/CosNotifyChannelAdmin/StructuredProxyPullConsumer:1.0",
                                                                                          "StructuredProxyPullConsumer"},
                                                                                      [{tk_objref,
                                                                                           "IDL:omg.org/CosNotifyComm/StructuredPullSupplier:1.0",
                                                                                           "StructuredPullSupplier"},
                                                                                       tk_long],
                                                                                      []}, infinity).

%%%% Operation: connect_sequence_push_consumer_with_id
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
connect_sequence_push_consumer_with_id(OE_THIS, Client, Channel) ->
    corba:call(OE_THIS, connect_sequence_push_consumer_with_id, [Client, Channel], {{tk_objref,
                                                                                        "IDL:omg.org/CosNotifyChannelAdmin/SequenceProxyPushSupplier:1.0",
                                                                                        "SequenceProxyPushSupplier"},
                                                                                    [{tk_objref,
                                                                                         "IDL:omg.org/CosNotifyComm/SequencePushConsumer:1.0",
                                                                                         "SequencePushConsumer"},
                                                                                     tk_long],
                                                                                    []}, infinity).

%%%% Operation: connect_sequence_pull_consumer_with_id
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
connect_sequence_pull_consumer_with_id(OE_THIS, Client, Channel) ->
    corba:call(OE_THIS, connect_sequence_pull_consumer_with_id, [Client, Channel], {{tk_objref,
                                                                                        "IDL:omg.org/CosNotifyChannelAdmin/SequenceProxyPullSupplier:1.0",
                                                                                        "SequenceProxyPullSupplier"},
                                                                                    [{tk_objref,
                                                                                         "IDL:omg.org/CosNotifyComm/SequencePullConsumer:1.0",
                                                                                         "SequencePullConsumer"},
                                                                                     tk_long],
                                                                                    []}, infinity).

%%%% Operation: connect_sequence_push_supplier_with_id
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
connect_sequence_push_supplier_with_id(OE_THIS, Client, Channel) ->
    corba:call(OE_THIS, connect_sequence_push_supplier_with_id, [Client, Channel], {{tk_objref,
                                                                                        "IDL:omg.org/CosNotifyChannelAdmin/SequenceProxyPushConsumer:1.0",
                                                                                        "SequenceProxyPushConsumer"},
                                                                                    [{tk_objref,
                                                                                         "IDL:omg.org/CosNotifyComm/SequencePushSupplier:1.0",
                                                                                         "SequencePushSupplier"},
                                                                                     tk_long],
                                                                                    []}, infinity).

%%%% Operation: connect_sequence_pull_supplier_with_id
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
connect_sequence_pull_supplier_with_id(OE_THIS, Client, Channel) ->
    corba:call(OE_THIS, connect_sequence_pull_supplier_with_id, [Client, Channel], {{tk_objref,
                                                                                        "IDL:omg.org/CosNotifyChannelAdmin/SequenceProxyPullConsumer:1.0",
                                                                                        "SequenceProxyPullConsumer"},
                                                                                    [{tk_objref,
                                                                                         "IDL:omg.org/CosNotifyComm/SequencePullSupplier:1.0",
                                                                                         "SequencePullSupplier"},
                                                                                     tk_long],
                                                                                    []}, infinity).

%%%% Operation: get_qos
%% 
%%   Returns: RetVal
%%
get_qos(OE_THIS) ->
    corba:call(OE_THIS, get_qos, [], {{tk_sequence,
                                          {tk_struct,
                                              "IDL:omg.org/CosNotification/Property:1.0",
                                              "Property",
                                              [{"name",{tk_string,0}},
                                               {"value",tk_any}]},
                                          0},
                                      [],
                                      []}, infinity).

%%%% Operation: set_qos
%% 
%%   Returns: RetVal
%%   Raises:  CosNotification::UnsupportedQoS
%%
set_qos(OE_THIS, Qos) ->
    corba:call(OE_THIS, set_qos, [Qos], {tk_void,
                                            [{tk_sequence,
                                                 {tk_struct,
                                                     "IDL:omg.org/CosNotification/Property:1.0",
                                                     "Property",
                                                     [{"name",{tk_string,0}},
                                                      {"value",tk_any}]},
                                                 0}],
                                            []}, infinity).

%%%% Operation: validate_qos
%% 
%%   Returns: RetVal, Available_qos
%%   Raises:  CosNotification::UnsupportedQoS
%%
validate_qos(OE_THIS, Required_qos) ->
    corba:call(OE_THIS, validate_qos, [Required_qos], {tk_void,
                                                          [{tk_sequence,
                                                               {tk_struct,
                                                                   "IDL:omg.org/CosNotification/Property:1.0",
                                                                   "Property",
                                                                   [{"name",
                                                                     {tk_string,
                                                                         0}},
                                                                    {"value",
                                                                     tk_any}]},
                                                               0}],
                                                          [{tk_sequence,
                                                               {tk_struct,
                                                                   "IDL:omg.org/CosNotification/NamedPropertyRange:1.0",
                                                                   "NamedPropertyRange",
                                                                   [{"name",
                                                                     {tk_string,
                                                                         0}},
                                                                    {"range",
                                                                     {tk_struct,
                                                                         "IDL:omg.org/CosNotification/PropertyRange:1.0",
                                                                         "PropertyRange",
                                                                         [{"low_val",
                                                                           tk_any},
                                                                          {"high_val",
                                                                           tk_any}]}}]},
                                                               0}]}, infinity).

%%%% Operation: get_admin
%% 
%%   Returns: RetVal
%%
get_admin(OE_THIS) ->
    corba:call(OE_THIS, get_admin, [], {{tk_sequence,
                                            {tk_struct,
                                                "IDL:omg.org/CosNotification/Property:1.0",
                                                "Property",
                                                [{"name",{tk_string,0}},
                                                 {"value",tk_any}]},
                                            0},
                                        [],
                                        []}, infinity).

%%%% Operation: set_admin
%% 
%%   Returns: RetVal
%%   Raises:  CosNotification::UnsupportedAdmin
%%
set_admin(OE_THIS, Admin) ->
    corba:call(OE_THIS, set_admin, [Admin], {tk_void,
                                                [{tk_sequence,
                                                     {tk_struct,
                                                         "IDL:omg.org/CosNotification/Property:1.0",
                                                         "Property",
                                                         [{"name",
                                                           {tk_string,0}},
                                                          {"value",tk_any}]},
                                                     0}],
                                                []}, infinity).

%%------------------------------------------------------------
%%
%% Inherited Interfaces
%%
%%------------------------------------------------------------
oe_is_a("IDL:omg.org/CosEventDomainAdmin/EventDomain:1.0") -> true;
oe_is_a("IDL:omg.org/CosNotification/QoSAdmin:1.0") -> true;
oe_is_a("IDL:omg.org/CosNotification/AdminPropertiesAdmin:1.0") -> true;
oe_is_a(_) -> false.



%%------------------------------------------------------------
%%
%% Object server implementation.
%%
%%------------------------------------------------------------


%%------------------------------------------------------------
%%
%% Function for fetching the interface type ID.
%%
%%------------------------------------------------------------

typeID() ->
    "IDL:omg.org/CosEventDomainAdmin/EventDomain:1.0".


%%------------------------------------------------------------
%%
%% Object creation functions.
%%
%%------------------------------------------------------------

oe_create() ->
    corba:create(?MODULE, "IDL:omg.org/CosEventDomainAdmin/EventDomain:1.0").

oe_create_link() ->
    corba:create_link(?MODULE, "IDL:omg.org/CosEventDomainAdmin/EventDomain:1.0").

oe_create(Env) ->
    corba:create(?MODULE, "IDL:omg.org/CosEventDomainAdmin/EventDomain:1.0", Env).

oe_create_link(Env) ->
    corba:create_link(?MODULE, "IDL:omg.org/CosEventDomainAdmin/EventDomain:1.0", Env).

oe_create(Env, RegName) ->
    corba:create(?MODULE, "IDL:omg.org/CosEventDomainAdmin/EventDomain:1.0", Env, RegName).

oe_create_link(Env, RegName) ->
    corba:create_link(?MODULE, "IDL:omg.org/CosEventDomainAdmin/EventDomain:1.0", Env, RegName).

%%------------------------------------------------------------
%%
%% Start functions.
%%
%%------------------------------------------------------------

start(Env) ->
    gen_server:start(?MODULE, Env, []).

start_link(Env) ->
    gen_server:start_link(?MODULE, Env, []).

%%------------------------------------------------------------
%%
%% Init & terminate functions.
%%
%%------------------------------------------------------------

init(Env) ->
%% Call to implementation init
    'CosEventDomainAdmin_EventDomain_impl':init(Env).

terminate(Reason, State) ->
    catch ('CosEventDomainAdmin_EventDomain_impl':terminate(Reason, State)).

%%------------------------------------------------------------
%%
%% Call & Cast macros.
%%
%%------------------------------------------------------------

-define(OE_CALL(Mod, Fun, Args),
        Result = case catch apply(Mod, Fun, Args) of
            {'EXIT', OE} -> exit(OE);
            OE_1 when element(1, OE_1)=='EXCEPTION' ->
                {reply, OE_1, OE_State};
            OE_2 when element(1, OE_2)=='reply' ->
                OE_2;
            OE_3 when element(1, OE_3)=='noreply' ->
                OE_3;
            OE_4 when element(1, OE_4)=='stop' ->
                OE_4;
            {OE_Reply, OE_NewState} -> {reply, OE_Reply, OE_NewState}
        end).
-define(OE_CAST(Mod, Fun, Args),
        Result = case catch apply(Mod, Fun, Args) of
            {'EXIT', OE} -> exit(OE);
            OE_1 when element(1, OE_1)=='EXCEPTION' ->
                {noreply, OE_State};
            OE_2 when element(1, OE_2)=='noreply' ->
                OE_2;
            OE_3 when element(1, OE_3)=='stop' ->
                OE_3;
            OE_NewState -> {noreply, OE_NewState}
        end).



%%%% Operation: add_channel
%% 
%%   Returns: RetVal
%%
handle_call({OE_THIS, add_channel, [Channel]}, OE_From, OE_State) ->
  ?OE_CALL('CosEventDomainAdmin_EventDomain_impl', add_channel, [OE_THIS, OE_State, Channel]);

%%%% Operation: get_all_channels
%% 
%%   Returns: RetVal
%%
handle_call({OE_THIS, get_all_channels, []}, OE_From, OE_State) ->
  ?OE_CALL('CosEventDomainAdmin_EventDomain_impl', get_all_channels, [OE_THIS, OE_State]);

%%%% Operation: get_channel
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
handle_call({OE_THIS, get_channel, [Channel]}, OE_From, OE_State) ->
  ?OE_CALL('CosEventDomainAdmin_EventDomain_impl', get_channel, [OE_THIS, OE_State, Channel]);

%%%% Operation: remove_channel
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
handle_call({OE_THIS, remove_channel, [Channel]}, OE_From, OE_State) ->
  ?OE_CALL('CosEventDomainAdmin_EventDomain_impl', remove_channel, [OE_THIS, OE_State, Channel]);

%%%% Operation: add_connection
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound, CosEventChannelAdmin::TypeError, CosEventDomainAdmin::AlreadyExists, CosEventDomainAdmin::CycleCreationForbidden, CosEventDomainAdmin::DiamondCreationForbidden
%%
handle_call({OE_THIS, add_connection, [Connection]}, OE_From, OE_State) ->
  ?OE_CALL('CosEventDomainAdmin_EventDomain_impl', add_connection, [OE_THIS, OE_State, Connection]);

%%%% Operation: get_all_connections
%% 
%%   Returns: RetVal
%%
handle_call({OE_THIS, get_all_connections, []}, OE_From, OE_State) ->
  ?OE_CALL('CosEventDomainAdmin_EventDomain_impl', get_all_connections, [OE_THIS, OE_State]);

%%%% Operation: get_connection
%% 
%%   Returns: RetVal
%%   Raises:  CosEventDomainAdmin::ConnectionNotFound
%%
handle_call({OE_THIS, get_connection, [Connection]}, OE_From, OE_State) ->
  ?OE_CALL('CosEventDomainAdmin_EventDomain_impl', get_connection, [OE_THIS, OE_State, Connection]);

%%%% Operation: remove_connection
%% 
%%   Returns: RetVal
%%   Raises:  CosEventDomainAdmin::ConnectionNotFound
%%
handle_call({OE_THIS, remove_connection, [Connection]}, OE_From, OE_State) ->
  ?OE_CALL('CosEventDomainAdmin_EventDomain_impl', remove_connection, [OE_THIS, OE_State, Connection]);

%%%% Operation: get_offer_channels
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
handle_call({OE_THIS, get_offer_channels, [Channel]}, OE_From, OE_State) ->
  ?OE_CALL('CosEventDomainAdmin_EventDomain_impl', get_offer_channels, [OE_THIS, OE_State, Channel]);

%%%% Operation: get_subscription_channels
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
handle_call({OE_THIS, get_subscription_channels, [Channel]}, OE_From, OE_State) ->
  ?OE_CALL('CosEventDomainAdmin_EventDomain_impl', get_subscription_channels, [OE_THIS, OE_State, Channel]);

%%%% Operation: destroy
%% 
%%   Returns: RetVal
%%
handle_call({OE_THIS, destroy, []}, OE_From, OE_State) ->
  ?OE_CALL('CosEventDomainAdmin_EventDomain_impl', destroy, [OE_THIS, OE_State]);

%%%% Operation: get_cycles
%% 
%%   Returns: RetVal
%%
handle_call({OE_THIS, get_cycles, []}, OE_From, OE_State) ->
  ?OE_CALL('CosEventDomainAdmin_EventDomain_impl', get_cycles, [OE_THIS, OE_State]);

%%%% Operation: get_diamonds
%% 
%%   Returns: RetVal
%%
handle_call({OE_THIS, get_diamonds, []}, OE_From, OE_State) ->
  ?OE_CALL('CosEventDomainAdmin_EventDomain_impl', get_diamonds, [OE_THIS, OE_State]);

%%%% Operation: set_default_consumer_channel
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
handle_call({OE_THIS, set_default_consumer_channel, [Channel]}, OE_From, OE_State) ->
  ?OE_CALL('CosEventDomainAdmin_EventDomain_impl', set_default_consumer_channel, [OE_THIS, OE_State, Channel]);

%%%% Operation: set_default_supplier_channel
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
handle_call({OE_THIS, set_default_supplier_channel, [Channel]}, OE_From, OE_State) ->
  ?OE_CALL('CosEventDomainAdmin_EventDomain_impl', set_default_supplier_channel, [OE_THIS, OE_State, Channel]);

%%%% Operation: connect_push_consumer
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
handle_call({OE_THIS, connect_push_consumer, [Client]}, OE_From, OE_State) ->
  ?OE_CALL('CosEventDomainAdmin_EventDomain_impl', connect_push_consumer, [OE_THIS, OE_State, Client]);

%%%% Operation: connect_pull_consumer
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
handle_call({OE_THIS, connect_pull_consumer, [Client]}, OE_From, OE_State) ->
  ?OE_CALL('CosEventDomainAdmin_EventDomain_impl', connect_pull_consumer, [OE_THIS, OE_State, Client]);

%%%% Operation: connect_push_supplier
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
handle_call({OE_THIS, connect_push_supplier, [Client]}, OE_From, OE_State) ->
  ?OE_CALL('CosEventDomainAdmin_EventDomain_impl', connect_push_supplier, [OE_THIS, OE_State, Client]);

%%%% Operation: connect_pull_supplier
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
handle_call({OE_THIS, connect_pull_supplier, [Client]}, OE_From, OE_State) ->
  ?OE_CALL('CosEventDomainAdmin_EventDomain_impl', connect_pull_supplier, [OE_THIS, OE_State, Client]);

%%%% Operation: connect_structured_push_consumer
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
handle_call({OE_THIS, connect_structured_push_consumer, [Client]}, OE_From, OE_State) ->
  ?OE_CALL('CosEventDomainAdmin_EventDomain_impl', connect_structured_push_consumer, [OE_THIS, OE_State, Client]);

%%%% Operation: connect_structured_pull_consumer
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
handle_call({OE_THIS, connect_structured_pull_consumer, [Client]}, OE_From, OE_State) ->
  ?OE_CALL('CosEventDomainAdmin_EventDomain_impl', connect_structured_pull_consumer, [OE_THIS, OE_State, Client]);

%%%% Operation: connect_structured_push_supplier
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
handle_call({OE_THIS, connect_structured_push_supplier, [Client]}, OE_From, OE_State) ->
  ?OE_CALL('CosEventDomainAdmin_EventDomain_impl', connect_structured_push_supplier, [OE_THIS, OE_State, Client]);

%%%% Operation: connect_structured_pull_supplier
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
handle_call({OE_THIS, connect_structured_pull_supplier, [Client]}, OE_From, OE_State) ->
  ?OE_CALL('CosEventDomainAdmin_EventDomain_impl', connect_structured_pull_supplier, [OE_THIS, OE_State, Client]);

%%%% Operation: connect_sequence_push_consumer
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
handle_call({OE_THIS, connect_sequence_push_consumer, [Client]}, OE_From, OE_State) ->
  ?OE_CALL('CosEventDomainAdmin_EventDomain_impl', connect_sequence_push_consumer, [OE_THIS, OE_State, Client]);

%%%% Operation: connect_sequence_pull_consumer
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
handle_call({OE_THIS, connect_sequence_pull_consumer, [Client]}, OE_From, OE_State) ->
  ?OE_CALL('CosEventDomainAdmin_EventDomain_impl', connect_sequence_pull_consumer, [OE_THIS, OE_State, Client]);

%%%% Operation: connect_sequence_push_supplier
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
handle_call({OE_THIS, connect_sequence_push_supplier, [Client]}, OE_From, OE_State) ->
  ?OE_CALL('CosEventDomainAdmin_EventDomain_impl', connect_sequence_push_supplier, [OE_THIS, OE_State, Client]);

%%%% Operation: connect_sequence_pull_supplier
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
handle_call({OE_THIS, connect_sequence_pull_supplier, [Client]}, OE_From, OE_State) ->
  ?OE_CALL('CosEventDomainAdmin_EventDomain_impl', connect_sequence_pull_supplier, [OE_THIS, OE_State, Client]);

%%%% Operation: connect_push_consumer_with_id
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
handle_call({OE_THIS, connect_push_consumer_with_id, [Client, Channel]}, OE_From, OE_State) ->
  ?OE_CALL('CosEventDomainAdmin_EventDomain_impl', connect_push_consumer_with_id, [OE_THIS, OE_State, Client, Channel]);

%%%% Operation: connect_pull_consumer_with_id
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
handle_call({OE_THIS, connect_pull_consumer_with_id, [Client, Channel]}, OE_From, OE_State) ->
  ?OE_CALL('CosEventDomainAdmin_EventDomain_impl', connect_pull_consumer_with_id, [OE_THIS, OE_State, Client, Channel]);

%%%% Operation: connect_push_supplier_with_id
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
handle_call({OE_THIS, connect_push_supplier_with_id, [Client, Channel]}, OE_From, OE_State) ->
  ?OE_CALL('CosEventDomainAdmin_EventDomain_impl', connect_push_supplier_with_id, [OE_THIS, OE_State, Client, Channel]);

%%%% Operation: connect_pull_supplier_with_id
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
handle_call({OE_THIS, connect_pull_supplier_with_id, [Client, Channel]}, OE_From, OE_State) ->
  ?OE_CALL('CosEventDomainAdmin_EventDomain_impl', connect_pull_supplier_with_id, [OE_THIS, OE_State, Client, Channel]);

%%%% Operation: connect_structured_push_consumer_with_id
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
handle_call({OE_THIS, connect_structured_push_consumer_with_id, [Client, Channel]}, OE_From, OE_State) ->
  ?OE_CALL('CosEventDomainAdmin_EventDomain_impl', connect_structured_push_consumer_with_id, [OE_THIS, OE_State, Client, Channel]);

%%%% Operation: connect_structured_pull_consumer_with_id
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
handle_call({OE_THIS, connect_structured_pull_consumer_with_id, [Client, Channel]}, OE_From, OE_State) ->
  ?OE_CALL('CosEventDomainAdmin_EventDomain_impl', connect_structured_pull_consumer_with_id, [OE_THIS, OE_State, Client, Channel]);

%%%% Operation: connect_structured_push_supplier_with_id
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
handle_call({OE_THIS, connect_structured_push_supplier_with_id, [Client, Channel]}, OE_From, OE_State) ->
  ?OE_CALL('CosEventDomainAdmin_EventDomain_impl', connect_structured_push_supplier_with_id, [OE_THIS, OE_State, Client, Channel]);

%%%% Operation: connect_structured_pull_supplier_with_id
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
handle_call({OE_THIS, connect_structured_pull_supplier_with_id, [Client, Channel]}, OE_From, OE_State) ->
  ?OE_CALL('CosEventDomainAdmin_EventDomain_impl', connect_structured_pull_supplier_with_id, [OE_THIS, OE_State, Client, Channel]);

%%%% Operation: connect_sequence_push_consumer_with_id
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
handle_call({OE_THIS, connect_sequence_push_consumer_with_id, [Client, Channel]}, OE_From, OE_State) ->
  ?OE_CALL('CosEventDomainAdmin_EventDomain_impl', connect_sequence_push_consumer_with_id, [OE_THIS, OE_State, Client, Channel]);

%%%% Operation: connect_sequence_pull_consumer_with_id
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
handle_call({OE_THIS, connect_sequence_pull_consumer_with_id, [Client, Channel]}, OE_From, OE_State) ->
  ?OE_CALL('CosEventDomainAdmin_EventDomain_impl', connect_sequence_pull_consumer_with_id, [OE_THIS, OE_State, Client, Channel]);

%%%% Operation: connect_sequence_push_supplier_with_id
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
handle_call({OE_THIS, connect_sequence_push_supplier_with_id, [Client, Channel]}, OE_From, OE_State) ->
  ?OE_CALL('CosEventDomainAdmin_EventDomain_impl', connect_sequence_push_supplier_with_id, [OE_THIS, OE_State, Client, Channel]);

%%%% Operation: connect_sequence_pull_supplier_with_id
%% 
%%   Returns: RetVal
%%   Raises:  CosNotifyChannelAdmin::ChannelNotFound
%%
handle_call({OE_THIS, connect_sequence_pull_supplier_with_id, [Client, Channel]}, OE_From, OE_State) ->
  ?OE_CALL('CosEventDomainAdmin_EventDomain_impl', connect_sequence_pull_supplier_with_id, [OE_THIS, OE_State, Client, Channel]);

%%%% Operation: get_qos
%% 
%%   Returns: RetVal
%%
handle_call({OE_THIS, get_qos, []}, OE_From, OE_State) ->
  ?OE_CALL('CosEventDomainAdmin_EventDomain_impl', get_qos, [OE_THIS, OE_State]);

%%%% Operation: set_qos
%% 
%%   Returns: RetVal
%%   Raises:  CosNotification::UnsupportedQoS
%%
handle_call({OE_THIS, set_qos, [Qos]}, OE_From, OE_State) ->
  ?OE_CALL('CosEventDomainAdmin_EventDomain_impl', set_qos, [OE_THIS, OE_State, Qos]);

%%%% Operation: validate_qos
%% 
%%   Returns: RetVal, Available_qos
%%   Raises:  CosNotification::UnsupportedQoS
%%
handle_call({OE_THIS, validate_qos, [Required_qos]}, OE_From, OE_State) ->
  ?OE_CALL('CosEventDomainAdmin_EventDomain_impl', validate_qos, [OE_THIS, OE_State, Required_qos]);

%%%% Operation: get_admin
%% 
%%   Returns: RetVal
%%
handle_call({OE_THIS, get_admin, []}, OE_From, OE_State) ->
  ?OE_CALL('CosEventDomainAdmin_EventDomain_impl', get_admin, [OE_THIS, OE_State]);

%%%% Operation: set_admin
%% 
%%   Returns: RetVal
%%   Raises:  CosNotification::UnsupportedAdmin
%%
handle_call({OE_THIS, set_admin, [Admin]}, OE_From, OE_State) ->
  ?OE_CALL('CosEventDomainAdmin_EventDomain_impl', set_admin, [OE_THIS, OE_State, Admin]);

%%%% Standard Operation: oe_get_interface
%%
handle_call({OE_THIS, oe_get_interface, []}, From, State) ->
    {reply, [{"get_qos",
              {{tk_sequence,{tk_struct,
                                "IDL:omg.org/CosNotification/Property:1.0",
                                "Property",
                                [{"name",{tk_string,0}},{"value",tk_any}]},
                            0},
               [],
               []}},
             {"set_qos",
              {tk_void,[{tk_sequence,{tk_struct,
                                         "IDL:omg.org/CosNotification/Property:1.0",
                                         "Property",
                                         [{"name",{tk_string,0}},
                                          {"value",tk_any}]},
                                     0}],
                       []}},
             {"validate_qos",
              {tk_void,[{tk_sequence,{tk_struct,
                                         "IDL:omg.org/CosNotification/Property:1.0",
                                         "Property",
                                         [{"name",{tk_string,0}},
                                          {"value",tk_any}]},
                                     0}],
                       [{tk_sequence,{tk_struct,
                                         "IDL:omg.org/CosNotification/NamedPropertyRange:1.0",
                                         "NamedPropertyRange",
                                         [{"name",{tk_string,0}},
                                          {"range",
                                           {tk_struct,
                                               "IDL:omg.org/CosNotification/PropertyRange:1.0",
                                               "PropertyRange",
                                               [{"low_val",tk_any},
                                                {"high_val",tk_any}]}}]},
                                     0}]}},
             {"get_admin",
              {{tk_sequence,{tk_struct,
                                "IDL:omg.org/CosNotification/Property:1.0",
                                "Property",
                                [{"name",{tk_string,0}},{"value",tk_any}]},
                            0},
               [],
               []}},
             {"set_admin",
              {tk_void,[{tk_sequence,{tk_struct,
                                         "IDL:omg.org/CosNotification/Property:1.0",
                                         "Property",
                                         [{"name",{tk_string,0}},
                                          {"value",tk_any}]},
                                     0}],
                       []}},
             {"add_channel",
              {tk_long,[{tk_objref,"IDL:omg.org/CosNotifyChannelAdmin/EventChannel:1.0",
                                   "EventChannel"}],
                       []}},
             {"get_all_channels",{{tk_sequence,tk_long,0},[],[]}},
             {"get_channel",
              {{tk_objref,"IDL:omg.org/CosNotifyChannelAdmin/EventChannel:1.0",
                          "EventChannel"},
               [tk_long],
               []}},
             {"remove_channel",{tk_void,[tk_long],[]}},
             {"add_connection",
              {tk_long,[{tk_struct,"IDL:omg.org/CosEventDomainAdmin/Connection:1.0",
                                   "Connection",
                                   [{"supplier_id",tk_long},
                                    {"consumer_id",tk_long},
                                    {"ctype",
                                     {tk_enum,
                                         "IDL:omg.org/CosNotifyChannelAdmin/ClientType:1.0",
                                         "ClientType",
                                         ["ANY_EVENT",
                                          "STRUCTURED_EVENT",
                                          "SEQUENCE_EVENT"]}},
                                    {"notification_style",
                                     {tk_enum,
                                         "IDL:omg.org/CosEventDomainAdmin/NotificationStyle:1.0",
                                         "NotificationStyle",
                                         ["Push","Pull"]}}]}],
                       []}},
             {"get_all_connections",{{tk_sequence,tk_long,0},[],[]}},
             {"get_connection",
              {{tk_struct,"IDL:omg.org/CosEventDomainAdmin/Connection:1.0",
                          "Connection",
                          [{"supplier_id",tk_long},
                           {"consumer_id",tk_long},
                           {"ctype",
                            {tk_enum,"IDL:omg.org/CosNotifyChannelAdmin/ClientType:1.0",
                                     "ClientType",
                                     ["ANY_EVENT",
                                      "STRUCTURED_EVENT",
                                      "SEQUENCE_EVENT"]}},
                           {"notification_style",
                            {tk_enum,"IDL:omg.org/CosEventDomainAdmin/NotificationStyle:1.0",
                                     "NotificationStyle",
                                     ["Push","Pull"]}}]},
               [tk_long],
               []}},
             {"remove_connection",{tk_void,[tk_long],[]}},
             {"get_offer_channels",{{tk_sequence,tk_long,0},[tk_long],[]}},
             {"get_subscription_channels",
              {{tk_sequence,tk_long,0},[tk_long],[]}},
             {"destroy",{tk_void,[],[]}},
             {"get_cycles",{{tk_sequence,{tk_sequence,tk_long,0},0},[],[]}},
             {"get_diamonds",
              {{tk_sequence,{tk_sequence,{tk_sequence,tk_long,0},0},0},[],[]}},
             {"set_default_consumer_channel",{tk_void,[tk_long],[]}},
             {"set_default_supplier_channel",{tk_void,[tk_long],[]}},
             {"connect_push_consumer",
              {{tk_objref,"IDL:omg.org/CosNotifyChannelAdmin/ProxyPushSupplier:1.0",
                          "ProxyPushSupplier"},
               [{tk_objref,"IDL:omg.org/CosEventComm/PushConsumer:1.0",
                           "PushConsumer"}],
               []}},
             {"connect_pull_consumer",
              {{tk_objref,"IDL:omg.org/CosNotifyChannelAdmin/ProxyPullSupplier:1.0",
                          "ProxyPullSupplier"},
               [{tk_objref,"IDL:omg.org/CosEventComm/PullConsumer:1.0",
                           "PullConsumer"}],
               []}},
             {"connect_push_supplier",
              {{tk_objref,"IDL:omg.org/CosNotifyChannelAdmin/ProxyPushConsumer:1.0",
                          "ProxyPushConsumer"},
               [{tk_objref,"IDL:omg.org/CosEventComm/PushSupplier:1.0",
                           "PushSupplier"}],
               []}},
             {"connect_pull_supplier",
              {{tk_objref,"IDL:omg.org/CosNotifyChannelAdmin/ProxyPullConsumer:1.0",
                          "ProxyPullConsumer"},
               [{tk_objref,"IDL:omg.org/CosEventComm/PullSupplier:1.0",
                           "PullSupplier"}],
               []}},
             {"connect_structured_push_consumer",
              {{tk_objref,"IDL:omg.org/CosNotifyChannelAdmin/StructuredProxyPushSupplier:1.0",
                          "StructuredProxyPushSupplier"},
               [{tk_objref,"IDL:omg.org/CosNotifyComm/StructuredPushConsumer:1.0",
                           "StructuredPushConsumer"}],
               []}},
             {"connect_structured_pull_consumer",
              {{tk_objref,"IDL:omg.org/CosNotifyChannelAdmin/StructuredProxyPullSupplier:1.0",
                          "StructuredProxyPullSupplier"},
               [{tk_objref,"IDL:omg.org/CosNotifyComm/StructuredPullConsumer:1.0",
                           "StructuredPullConsumer"}],
               []}},
             {"connect_structured_push_supplier",
              {{tk_objref,"IDL:omg.org/CosNotifyChannelAdmin/StructuredProxyPushConsumer:1.0",
                          "StructuredProxyPushConsumer"},
               [{tk_objref,"IDL:omg.org/CosNotifyComm/StructuredPushSupplier:1.0",
                           "StructuredPushSupplier"}],
               []}},
             {"connect_structured_pull_supplier",
              {{tk_objref,"IDL:omg.org/CosNotifyChannelAdmin/StructuredProxyPullConsumer:1.0",
                          "StructuredProxyPullConsumer"},
               [{tk_objref,"IDL:omg.org/CosNotifyComm/StructuredPullSupplier:1.0",
                           "StructuredPullSupplier"}],
               []}},
             {"connect_sequence_push_consumer",
              {{tk_objref,"IDL:omg.org/CosNotifyChannelAdmin/SequenceProxyPushSupplier:1.0",
                          "SequenceProxyPushSupplier"},
               [{tk_objref,"IDL:omg.org/CosNotifyComm/SequencePushConsumer:1.0",
                           "SequencePushConsumer"}],
               []}},
             {"connect_sequence_pull_consumer",
              {{tk_objref,"IDL:omg.org/CosNotifyChannelAdmin/SequenceProxyPullSupplier:1.0",
                          "SequenceProxyPullSupplier"},
               [{tk_objref,"IDL:omg.org/CosNotifyComm/SequencePullConsumer:1.0",
                           "SequencePullConsumer"}],
               []}},
             {"connect_sequence_push_supplier",
              {{tk_objref,"IDL:omg.org/CosNotifyChannelAdmin/SequenceProxyPushConsumer:1.0",
                          "SequenceProxyPushConsumer"},
               [{tk_objref,"IDL:omg.org/CosNotifyComm/SequencePushSupplier:1.0",
                           "SequencePushSupplier"}],
               []}},
             {"connect_sequence_pull_supplier",
              {{tk_objref,"IDL:omg.org/CosNotifyChannelAdmin/SequenceProxyPullConsumer:1.0",
                          "SequenceProxyPullConsumer"},
               [{tk_objref,"IDL:omg.org/CosNotifyComm/SequencePullSupplier:1.0",
                           "SequencePullSupplier"}],
               []}},
             {"connect_push_consumer_with_id",
              {{tk_objref,"IDL:omg.org/CosNotifyChannelAdmin/ProxyPushSupplier:1.0",
                          "ProxyPushSupplier"},
               [{tk_objref,"IDL:omg.org/CosEventComm/PushConsumer:1.0",
                           "PushConsumer"},
                tk_long],
               []}},
             {"connect_pull_consumer_with_id",
              {{tk_objref,"IDL:omg.org/CosNotifyChannelAdmin/ProxyPullSupplier:1.0",
                          "ProxyPullSupplier"},
               [{tk_objref,"IDL:omg.org/CosEventComm/PullConsumer:1.0",
                           "PullConsumer"},
                tk_long],
               []}},
             {"connect_push_supplier_with_id",
              {{tk_objref,"IDL:omg.org/CosNotifyChannelAdmin/ProxyPushConsumer:1.0",
                          "ProxyPushConsumer"},
               [{tk_objref,"IDL:omg.org/CosEventComm/PushSupplier:1.0",
                           "PushSupplier"},
                tk_long],
               []}},
             {"connect_pull_supplier_with_id",
              {{tk_objref,"IDL:omg.org/CosNotifyChannelAdmin/ProxyPullConsumer:1.0",
                          "ProxyPullConsumer"},
               [{tk_objref,"IDL:omg.org/CosEventComm/PullSupplier:1.0",
                           "PullSupplier"},
                tk_long],
               []}},
             {"connect_structured_push_consumer_with_id",
              {{tk_objref,"IDL:omg.org/CosNotifyChannelAdmin/StructuredProxyPushSupplier:1.0",
                          "StructuredProxyPushSupplier"},
               [{tk_objref,"IDL:omg.org/CosNotifyComm/StructuredPushConsumer:1.0",
                           "StructuredPushConsumer"},
                tk_long],
               []}},
             {"connect_structured_pull_consumer_with_id",
              {{tk_objref,"IDL:omg.org/CosNotifyChannelAdmin/StructuredProxyPullSupplier:1.0",
                          "StructuredProxyPullSupplier"},
               [{tk_objref,"IDL:omg.org/CosNotifyComm/StructuredPullConsumer:1.0",
                           "StructuredPullConsumer"},
                tk_long],
               []}},
             {"connect_structured_push_supplier_with_id",
              {{tk_objref,"IDL:omg.org/CosNotifyChannelAdmin/StructuredProxyPushConsumer:1.0",
                          "StructuredProxyPushConsumer"},
               [{tk_objref,"IDL:omg.org/CosNotifyComm/StructuredPushSupplier:1.0",
                           "StructuredPushSupplier"},
                tk_long],
               []}},
             {"connect_structured_pull_supplier_with_id",
              {{tk_objref,"IDL:omg.org/CosNotifyChannelAdmin/StructuredProxyPullConsumer:1.0",
                          "StructuredProxyPullConsumer"},
               [{tk_objref,"IDL:omg.org/CosNotifyComm/StructuredPullSupplier:1.0",
                           "StructuredPullSupplier"},
                tk_long],
               []}},
             {"connect_sequence_push_consumer_with_id",
              {{tk_objref,"IDL:omg.org/CosNotifyChannelAdmin/SequenceProxyPushSupplier:1.0",
                          "SequenceProxyPushSupplier"},
               [{tk_objref,"IDL:omg.org/CosNotifyComm/SequencePushConsumer:1.0",
                           "SequencePushConsumer"},
                tk_long],
               []}},
             {"connect_sequence_pull_consumer_with_id",
              {{tk_objref,"IDL:omg.org/CosNotifyChannelAdmin/SequenceProxyPullSupplier:1.0",
                          "SequenceProxyPullSupplier"},
               [{tk_objref,"IDL:omg.org/CosNotifyComm/SequencePullConsumer:1.0",
                           "SequencePullConsumer"},
                tk_long],
               []}},
             {"connect_sequence_push_supplier_with_id",
              {{tk_objref,"IDL:omg.org/CosNotifyChannelAdmin/SequenceProxyPushConsumer:1.0",
                          "SequenceProxyPushConsumer"},
               [{tk_objref,"IDL:omg.org/CosNotifyComm/SequencePushSupplier:1.0",
                           "SequencePushSupplier"},
                tk_long],
               []}},
             {"connect_sequence_pull_supplier_with_id",
              {{tk_objref,"IDL:omg.org/CosNotifyChannelAdmin/SequenceProxyPullConsumer:1.0",
                          "SequenceProxyPullConsumer"},
               [{tk_objref,"IDL:omg.org/CosNotifyComm/SequencePullSupplier:1.0",
                           "SequencePullSupplier"},
                tk_long],
               []}}], State};



%%%% Standard gen_server call handle
%%
handle_call(stop, From, State) ->
    {stop, normal, ok, State};

handle_call(Req, From, State) ->
    {reply, catch corba:raise(#'BAD_OPERATION'{minor=1163001857, completion_status='COMPLETED_NO'}), State}.


%%%% Standard gen_server cast handle
%%
handle_cast(stop, State) ->
    {stop, normal, State};

handle_cast(Req, State) ->
    {noreply, State}.


%%%% Standard gen_server handles
%%
handle_info(Info, State) ->
    'CosEventDomainAdmin_EventDomain_impl':handle_info(Info, State).


code_change(OldVsn, State, Extra) ->
    'CosEventDomainAdmin_EventDomain_impl':code_change(OldVsn, State, Extra).

